/*
 * This file or a portion of this file is licensed under the terms of the
 * Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without modifications,
 * you must include this notice in the file.
 */

#ifndef LOG_H
#define LOG_H
FILE *g_log_fp;
FILE *g_debug_fp;
int g_debug_level;

/* Output options */

#define DEBUG_FD stderr
#define DEBUG_LEVEL 1 /* 0-9 */

#define MAX_LOG_BUFFER_SIZE 2048

/* if defined, marks separate invocations to program */
#define LOG_SEPARATOR "___________________________________________________\n\n"

extern int log_init();
extern void log_msg(char *fmt, ...);
extern int debug_init();
extern void debug_msg(int debuglevel, char *fmt, ...);
extern char * get_time();

#endif  /* LOG_H */
