#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "log.h"
#include "util.h"
#include "errors.h"

/* __________________________________________________
   safe_dup
   _______________________________________________{{{ */
extern char * safe_dup(char * arg)
{
  debug_msg(8,"safe_dup()");
  char *dupped_arg;

  dupped_arg = (char *) malloc(SAFE_LEN * sizeof(char));
  if (dupped_arg == NULL)
  {
    fprintf(stderr, "Error: malloc for dup of argument string failed\n");
    exit(BADARG);
  } else { 
    if (arg) { 
      /*debug_msg(8,"safe_dup() arg: %s",arg);*/
      ;
    } else {
      debug_msg(1,"safe_dup() null arg");
      exit(BADARG);
    }
  }

  strncpy(dupped_arg, arg, SAFE_LEN);
  dupped_arg[SAFE_LEN - 1] = '\0';
  if (strlen(dupped_arg) == SAFE_LEN - 1)
  {
    fprintf(stderr, "Error: argument string length too long\n");
    exit(BADARG);
  } 
  return dupped_arg;
} /* safe_dup() }}} */



