/*
 * This file or a portion of this file is licensed under the terms of the
 * Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without modifications,
 * you must include this notice in the file.
 */
package org.globus.dynamicAccounts.impl.factory;

import org.globus.wsrf.impl.SimpleResourceKey;

import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.ResourceProperties;

import org.globus.dynamicAccounts.DynamicAccountsException;
import org.globus.dynamicAccounts.DynamicAccountsConstants;
import org.globus.dynamicAccounts.LimitException;

import org.globus.dynamicAccounts.types.AccountInformation;

import javax.xml.namespace.QName;

public interface DynamicAccountsFactoryResource 
    extends ResourceProperties, Resource {

    public static final QName RP_SET =
        new QName(DynamicAccountsConstants.NS, "DAFSRPSet");
    public static final String AUTHZ_FILE_SUFFIX = "AuthzFile";

    public void initialize(SimpleResourceKey key, Integer ttl, String host,
                           String authzInfoFile)
        throws Exception;
    
    public ResourceKey createAccount(AccountInformation accountInfo, String userName)
        throws DynamicAccountsException, LimitException;

    public void addAuthz(String dn, String localName)
        throws DynamicAccountsException;

    public void removeAuthz(String dn, String localName)
        throws DynamicAccountsException;

    public void deleteAccountAuthz(String localName)
        throws DynamicAccountsException;
}
