/*
 * This file or a portion of this file is licensed under the terms of the
 * Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without modifications,
 * you must include this notice in the file.
 */
package org.globus.dynamicAccounts.impl.service;

import org.globus.wsrf.Resource;
import org.globus.wsrf.RemoveCallback;
import org.globus.wsrf.ResourceLifetime;
import org.globus.wsrf.ResourceProperties;

import org.globus.dynamicAccounts.types.AccountInformation;
import org.globus.dynamicAccounts.types.VOMSAttributes;

import org.globus.dynamicAccounts.DynamicAccountsException;

public interface DynamicAccountsResource
    extends ResourceProperties, ResourceLifetime, RemoveCallback, Resource {
    
    public void initialize(String creationMechanism, String callerDN,
                           String callerUserName, String globusLocation,
                           int defaultTtl)
            throws DynamicAccountsException;

    public String createAccount(AccountInformation info)
            throws DynamicAccountsException;
    
    public void deleteAccount() throws DynamicAccountsException;
       
    public void addAuthzIdentity(String str) throws DynamicAccountsException;

    public void removeAuthzIdentity(String str)
        throws DynamicAccountsException;

    public String getLocalAccountName() throws DynamicAccountsException;

    public String getOwnerDN() throws DynamicAccountsException;

    public VOMSAttributes getVOMSAttributes() throws DynamicAccountsException;

}
